package net.sf.colorer.impl;

import java.util.Vector;

import net.sf.colorer.LineSource;
import net.sf.colorer.ParserFactory;
import net.sf.colorer.handlers.LineRegion;

public class CachedBaseEditor extends BaseEditorNative {

    private Vector cacheVector = new Vector();

    public CachedBaseEditor(ParserFactory pf, LineSource lineSource){
        super(pf, lineSource);
    }
    
    //FIXME: Should be implemented internally!!!
    public LineRegion[] getLineRegions(int lno) {
        LineRegion[] list = (LineRegion[])cacheVector.get(lno); 
        if (list == null) {
            list = super.getLineRegions(lno);
            cacheVector.set(lno, list);
        }
        return list;
    }

    public void modifyEvent(int topLine) {
        super.modifyEvent(topLine);
        while (topLine < cacheVector.size()){
            cacheVector.set(topLine, null);
            topLine++;
        }
    }

    public void modifyLineEvent(int line) {
        super.modifyLineEvent(line);
    }
    
    public void lineCountEvent(int newLineCount) {
        super.lineCountEvent(newLineCount);
        cacheVector.setSize(newLineCount);
    }
    
}

/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is the Colorer Library
 *
 * The Initial Developer of the Original Code is
 * Igor Russkih <irusskih at gmail dot com>.
 * Portions created by the Initial Developer are Copyright (C) 1999-2007
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */